function y = clean_row(mask, lsize)
 % for most rows
 % only keep the leftmost and the rightmost pixel
 
 % mask: the input mask image
 % lsize: for rows whose length between the leftmost pixel and the rightmost
 % pixel exceeds $lsize$, execute the function on the row
 
    row_len = size(mask, 2);
    
    for i=1:row_len
        id=find(mask(i,:)==1);
        min_id=min(id);
        max_id=max(id);
        if length(id)<lsize
            for j=1:length(id)
                if id(j)~=max_id && id(j)~=min_id
                    mask(i,id(j))=0;
                end
            end
        end
    end
    
    y = mask;
end