% EE368/CS232 Digital Image Processing
% Chenyu you
% Project
% Department of Electrical Engineering, Stanford University 

path = './EE368/project/cvpr16/aircraft/trainingShapes/';
len_dict = dir(path);
dict_name = len_dict(3).name;
savepath = './EE368/project/cvpr16/aircraft/trainingShapes_augumentation/';
mkdir(savepath);
suffix = '.png';
suffix2 = '.mat';
sz = 10;

% Define the input wanted from the original image
input_width = 64;
input_height = 64;

% Define how many pixels you want to shift, carefully calculate it with
% respect to the input width and the original image width.
shifting_value = [100/5,    1, 100/10,    1;
                    1,   100/5,    1, 100/10];
% Define the value for color shifting
shifting_color = [ 20, -20,  5, 50;
                  -20,  20,  0,  0;
                   20,  20, 50, -10];

for n = 1+2 : length(len_dict)
    file_name = len_dict(n).name;
    file_path = [path file_name];
    file_n = file_name(1:end-4);
    testImagefile = load(file_path, 'AlignedShapeMatrix');
    testImgs = testImagefile.AlignedShapeMatrix;
    height = size(testImgs, 2);
    for j = 1:height
        testImg = testImgs(:,j);
        testImg_s = reshape(testImg, [64, 64]);
        
        original_img(:,:,1) = testImg_s;
        original_img(:,:,2) = testImg_s;
        original_img(:,:,3) = testImg_s;
        
        % Crop the center image
%         original_center_img = center_crop(original_img, input_width, input_height, 0, 0);
        % Get R,G,B channel
        [red, green, blue] = get_color_channel(original_img);
        % Get the Greyscale channel
        gray = rgb2gray(original_img);
        subplot(4,6, [3 4 9 10]), imshow(original_img); title('Orginal');
        subplot(4,6,6), imshow(gray); title('Grayscale');
%         AlignedShapeMatrix = gray;
        file_nm = [file_n '_' 'Grayscale' '_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(gray,save_file_path);
        AlignedShapeMatrix = gray;
        file_nm2 = [file_n '_' 'Grayscale' '_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');
        
        subplot(4,6,12), imshow(red); title('Red channel');
        file_nm = [file_n '_Red_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(gray,save_file_path)
        AlignedShapeMatrix = red;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_' 'Red' '_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');

        subplot(4,6,18), imshow(green); title('Green channel');
        file_nm = [file_n '_Green_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(green,save_file_path)
        AlignedShapeMatrix = green;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_Green_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');

        subplot(4,6,24), imshow(blue); title('Blue channel');
        file_nm = [file_n '_Blue_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(blue,save_file_path)
        AlignedShapeMatrix = blue;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_Blue_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');

        % Add image noise
        img_noise = imnoise(original_img,'gaussian',0.04);
        subplot(4,6,15), imshow(img_noise); title('Add Gaussian noise');
        file_nm = [file_n '_gaussian_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(img_noise,save_file_path)
        AlignedShapeMatrix = img_noise;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_gaussian_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');

        img_noise = imnoise(original_img,'salt & pepper',0.04);
        subplot(4,6,16), imshow(img_noise); title('Add Salt & Pepper noise');
        file_nm = [file_n '_Salt_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(img_noise,save_file_path)
        AlignedShapeMatrix = img_noise;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_Salt_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');

        img_resized = imresize(original_img, [input_width input_height]);
        subplot(4,6,21), imshow(img_resized); title('Resize image');
        file_nm = [file_n '_Resize_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(img_resized,save_file_path)
        AlignedShapeMatrix = img_resized;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_Resize_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');

        img_rotated = imrotate(original_img, 5);
        subplot(4,6,22), imshow(img_rotated); title('Rotate image');
        file_nm = [file_n '_Rotate_' num2str(j) suffix];
        save_file_path = [savepath file_nm];
        imwrite(img_rotated,save_file_path)
        AlignedShapeMatrix = img_rotated;
%         save(save_file_path, 'AlignedShapeMatrix');
        file_nm2 = [file_n '_Rotate_' num2str(j) suffix2];
        save_file_path2 = [savepath file_nm2];
        save(save_file_path2, 'AlignedShapeMatrix');
        
        pic_id = -5;
        for i=1:4
            pic_id = pic_id+6;
            % Random center crop
            center_img = center_crop(original_img, input_width, input_height, shifting_value(1,i), shifting_value(2,i));
            subplot(4,6,pic_id), imshow(center_img); title('Random center crop');
            file_nm = [file_n '_RandomCenter_' num2str(j) '_' num2str(i) suffix];
            save_file_path = [savepath file_nm];
            imwrite(center_img,save_file_path);
            AlignedShapeMatrix = center_img;
            file_nm2 = [file_n '_RandomCenter_' num2str(j) '_' num2str(i) suffix2];
            save_file_path2 = [savepath file_nm2];
            save(save_file_path2, 'AlignedShapeMatrix');
            
            % Flip the image
            [flip] = flip_image(original_img);
            subplot(4,6,pic_id+1), imshow(flip); title('Mirror version');
            file_nm = [file_n '_Mirror_' num2str(j) '_' num2str(i) suffix];
            save_file_path = [savepath file_nm];
            imwrite(flip,save_file_path);
            AlignedShapeMatrix = flip;
            file_nm2 = [file_n '_Mirror_' num2str(j) '_' num2str(i) suffix2];
            save_file_path2 = [savepath file_nm2];
            save(save_file_path2, 'AlignedShapeMatrix');
            
            % Shift the color channel
            img_shiftcolor = color_shifting(original_img, shifting_color(1,i), shifting_color(2,i), shifting_color(3,i));
            subplot(4,6,pic_id+4), imshow(img_shiftcolor); title('Color shifting');
            file_nm = [file_n '_Color_' num2str(j) '_' num2str(i) suffix];
            save_file_path = [savepath file_nm];
            imwrite(img_shiftcolor,save_file_path);
            AlignedShapeMatrix = img_shiftcolor;
            file_nm2 = [file_n '_Color_' num2str(j) '_' num2str(i) suffix2];
            save_file_path2 = [savepath file_nm2];
            save(save_file_path2, 'AlignedShapeMatrix');
        end
    end
end