function y = hole_removal(mask, fname1, fname2)
    % mask1 is the input shape matrix
    % remove small foreground and background regions
    num_pixel = 20; 
    m1 = remove_small_hole(mask, num_pixel, 8, true);
    m2 = remove_small_hole(m1, num_pixel, 4, false);

    % detect large foreground regions and change them into edges
    big_region = remove_small_hole(m2, num_pixel, 4, false);
    m3 = region_to_edge(m2, big_region, 'canny');
   
    % only keep the leftmost and the rightmost pixel for most rows
    y = clean_row(m3, 7);
    
    % save output
    save(fname1, 'y');
    imwrite(y, fname2);

end