function y = remove_small_hole(mask, region_size, connect, is_fg)  
% this function removes small holes in an image

% mask: the input mask image
% region_size: remove regions that are smaller than the region_size
% connect: whether the region is defined as 8-pixel connected or 4-pixel
% connected
% is_fg: whether remove small regions in the foreground (true) 
% or background (false)

    % remove small regions in the foreground
    if is_fg == true
        y = bwareaopen(mask, region_size, connect);
    else % remove small regions in the background
        reverse = 1 - mask;
        r = bwareaopen(reverse, region_size, connect);
        y = 1 - r;
    end

end